//  Douglas M. Hurst
//  8912 Spur Road
//  Springfield, VA 22153
//  CompuServe 72767,1163
//
//  BAR39S  - is a program to print each character in the 3 of 9 bar code
//            character set WITHOUT THE REQUIREMENT OF AN EXTERNAL 
//            LIBRARY OR CARTRIDGE.  This program will work properly 
//            on HP LaserJet + and later and compatible printers.
//
#include <stdio.h>

char all[] = "$%*+,-./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
int pointx = 0;
int pointy = 0;
int cpi = 10;
int rpi =  6;

void main(void);
void hp_init();
void hp_deinit();
int  hp_printbar39(int, int, char *);
void hp_narrow_white(int *, int);
void hp_narrow_black(int *, int);
void hp_wide_white(int *, int);
void hp_wide_black(int *, int);
void hp_gotoxy(int, int);

void main(void)
{
  char jstr[2];
  int i,j,k;

  hp_init();

  jstr[1] = '\0';

  for (i = 0, k = 6 ; all[i] ; k+=6)
  {
    for (j=0 ; j < 80 && all[i]; j+=10, i++)
    {
      sprintf(jstr,"%c",all[i]);
      if (hp_printbar39(j+2,k,jstr))
      {
        printf("Non-Bar39 character in string.\n");
        exit(1);
      }
    }
  }

  fprintf(stdprn,"\33E");
}

// H P _ I N I T
//
void hp_init()
{
  fprintf(stdprn,"\33&l0O\33(s0p10h12v0s0b3T");
}
 
// H P _ D E I N I T
//
void hp_deinit()
{
  fprintf(stdprn,"\33E");
}

// H P _ P R I N T _ B A R
//
int hp_printbar39(int col, int row, char *code)
{
  char jstr[11];
  int i,j;

  hp_gotoxy(col,row);
  fprintf(stdprn,"%c=",code[0]);
  hp_gotoxy(col+2,row);

  for (i=0 ; code[i] ; i++)
  {
    switch(code[i])
    {
      case '$': strcpy(jstr,"-1-1-1----"); break;
      case '%': strcpy(jstr,"---1-1-1--"); break;
      case '*': strcpy(jstr,"-1--1-1---"); break;
      case '+': strcpy(jstr,"-1---1-1--"); break;
      case ',': strcpy(jstr,"-11---1---"); break;
      case '-': strcpy(jstr,"-1----1-1-"); break;
      case '.': strcpy(jstr,"11----1---"); break;
      case '/': strcpy(jstr,"-1-1---1--"); break;
      case '0': strcpy(jstr,"---11-1---"); break;
      case '1': strcpy(jstr,"1--1----1-"); break;
      case '2': strcpy(jstr,"--11----1-"); break;
      case '3': strcpy(jstr,"1-11------"); break;
      case '4': strcpy(jstr,"---11---1-"); break;
      case '5': strcpy(jstr,"1--11-----"); break;
      case '6': strcpy(jstr,"--111-----"); break;
      case '7': strcpy(jstr,"---1--1-1-"); break;
      case '8': strcpy(jstr,"1--1--1---"); break;
      case '9': strcpy(jstr,"--11--1---"); break;
      case 'A': strcpy(jstr,"1----1--1-"); break;
      case 'B': strcpy(jstr,"--1--1--1-"); break;
      case 'C': strcpy(jstr,"1-1--1----"); break;
      case 'D': strcpy(jstr,"----11--1-"); break;
      case 'E': strcpy(jstr,"1---11----"); break;
      case 'F': strcpy(jstr,"--1-11----"); break;
      case 'G': strcpy(jstr,"-----11-1-"); break;
      case 'H': strcpy(jstr,"1----11---"); break;
      case 'I': strcpy(jstr,"--1--11---"); break;
      case 'J': strcpy(jstr,"----111---"); break;
      case 'K': strcpy(jstr,"1------11-"); break;
      case 'L': strcpy(jstr,"--1----11-"); break;
      case 'M': strcpy(jstr,"1-1----1--"); break;
      case 'N': strcpy(jstr,"----1--11-"); break;
      case 'O': strcpy(jstr,"1---1--1--"); break;
      case 'P': strcpy(jstr,"--1-1--1--"); break;
      case 'Q': strcpy(jstr,"------111-"); break;
      case 'R': strcpy(jstr,"1-----11--"); break;
      case 'S': strcpy(jstr,"--1---11--"); break;
      case 'T': strcpy(jstr,"----1-11--"); break;
      case 'U': strcpy(jstr,"11------1-"); break;
      case 'V': strcpy(jstr,"-11-----1-"); break;
      case 'W': strcpy(jstr,"111-------"); break;
      case 'X': strcpy(jstr,"-1--1---1-"); break;
      case 'Y': strcpy(jstr,"11--1-----"); break;
      case 'Z': strcpy(jstr,"-11-1-----"); break;
      default:  return(1);
    }
    for (j=0 ; jstr[j] ; j++)
    {
      if (j % 2 == 0)
      {
        if (jstr[j] == '1')
          hp_wide_black(&pointx,pointy);
        else
          hp_narrow_black(&pointx,pointy);
      }
      else
      {
        if (jstr[j] == '1')
          hp_wide_white(&pointx,pointy);
        else
          hp_narrow_white(&pointx,pointy);
      }
    }
  } 
  return(0);
}

// H P _ N A R R O W _ W H I T E
//
void hp_narrow_white(int *px, int py)
{
  fprintf(stdprn,"\33*p%dx%dY\33*c3a180b1P",*px,py);
  *px = *px + 3;
}

// H P _ N A R R O W _ B L A C K
//
void hp_narrow_black(int *px, int py)
{
  fprintf(stdprn,"\33*p%dx%dY\33*c3a180b0P",*px,py);
  *px = *px + 3;
}

// H P _ W I D E _ W H I T E
//
void hp_wide_white(int *px, int py)
{
  fprintf(stdprn,"\33*p%dx%dY\33*c9a180b1P",*px,py);
  *px = *px + 9;
}

// H P _ W I D E _ B L A C K
//
void hp_wide_black(int *px, int py)
{
  fprintf(stdprn,"\33*p%dx%dY\33*c9a180b0P",*px,py);
  *px = *px + 9;
}

// H P _ G O T O X Y
//
void hp_gotoxy(int col, int row)
{
  fprintf(stdprn,"\33(8U\33(s0p%dh3T",cpi);
  fprintf(stdprn,"\33&a%dc%dR",col,row);
  pointx = (int)((float)col/(float)cpi*300.0);
  pointy = (int)((float)row/(float)rpi*300.0);
  fprintf(stdprn,"\33*p%dx%dY",pointx,pointy);
}

