//  Douglas M. Hurst
//  8912 Spur Road
//  Springfield, VA 22153
//  CompuServe 72767,1163
//
//  BARZIPS - is a program to print each character in the U.S. Postal Bar 
//            Code character set WITHOUT THE REQUIREMENT OF AN EXTERNAL 
//            LIBRARY OR CARTRIDGE.  This program will work properly 
//            on HP LaserJet + and later and compatible printers.
//
#include <stdio.h>

char all[] = "*0123456789|";

int pointx = 0;
int pointy = 0;
int cpi = 10;
int rpi =  6;

void main(void);
void hp_init();
void hp_deinit();
int  hp_printbarzip(int, int, char *);
void hp_white(int *, int);
void hp_tall_black(int *, int);
void hp_short_black(int *, int);
void hp_gotoxy(int, int);

void main(void)
{
  char jstr[2];
  int i,row,col;

  hp_init();

  for (i=0,row=6,col=10 ; all[i] ; i++,row+=2)
  {
    sprintf(jstr,"%c",all[i]);
    hp_printbarzip(col,row,jstr);
  }

  fprintf(stdprn,"\33E");
}

// H P _ I N I T
//
void hp_init()
{
  fprintf(stdprn,"\33&l0O\33(s0p10h12v0s0b3T");
}
 
// H P _ D E I N I T
//
void hp_deinit()
{
  fprintf(stdprn,"\33E");
}

// H P _ P R I N T B A R Z I P
//
int hp_printbarzip(int col, int row, char *code)
{
  char jstr[11];
  int i,j;

  hp_gotoxy(col,row);
  fprintf(stdprn,"%c=",code[0]);
  hp_gotoxy(col+2,row);

  for (i=0 ; code[i] ; i++)
  {
    switch(code[i])
    {
      case '*': strcpy(jstr,"1-"); break;
      case '0': strcpy(jstr,"1-1-0-0-0-"); break;
      case '1': strcpy(jstr,"0-0-0-1-1-"); break;
      case '2': strcpy(jstr,"0-0-1-0-1-"); break;
      case '3': strcpy(jstr,"0-0-1-1-0-"); break;
      case '4': strcpy(jstr,"0-1-0-0-1-"); break;
      case '5': strcpy(jstr,"0-1-0-1-0-"); break;
      case '6': strcpy(jstr,"0-1-1-0-0-"); break;
      case '7': strcpy(jstr,"1-0-0-0-1-"); break;
      case '8': strcpy(jstr,"1-0-0-1-0-"); break;
      case '9': strcpy(jstr,"1-0-1-0-0-"); break;
      case '|': strcpy(jstr,"1-"); break;
      default:  return(1);
    }
    for (j=0 ; jstr[j] ; j++)
    {
      if (j % 2 == 0)
      {
        if (jstr[j] == '1')
          hp_tall_black(&pointx,pointy);
        else
          hp_short_black(&pointx,pointy);
      }
      else
        hp_white(&pointx,pointy);
    }
  } 
  return(0);
}

// H P _ W H I T E
//
void hp_white(int *px, int py)
{
  fprintf(stdprn,"\33*p%dx%dY\33*c8a16b1P",*px,py+20);
  *px = *px + 7;
}

// H P _ S H O R T_ B L A C K
//
void hp_short_black(int *px, int py)
{
  fprintf(stdprn,"\33*p%dx%dY\33*c5a16b0P",*px,py+20);
  *px = *px + 7;
}

// H P _ T A L L _ B L A C K
//
void hp_tall_black(int *px, int py)
{
  fprintf(stdprn,"\33*p%dx%dY\33*c5a36b0P",*px,py);
  *px = *px + 7;
}

// H P _ G O T O X Y
//
void hp_gotoxy(int col, int row)
{
  fprintf(stdprn,"\33(8U\33(s0p%dh3T",cpi);
  fprintf(stdprn,"\33&a%dc%dR",col,row);
  pointx = (int)((float)col/(float)cpi*300.0);
  pointy = (int)((float)row/(float)rpi*300.0);
  fprintf(stdprn,"\33*p%dx%dY",pointx,pointy);
}


